#include "StdAfx.h"
#include "TelnetClient.h"
#include "TelnetRequest.h"

using namespace System::Net;
using namespace System::Net::Sockets;

cTelnetRequest::cTelnetRequest(void)
{
	String^ m_sRecvBuffer = gcnew String("");
}

void cTelnetRequest::FillRecvBuffer(String^ sRecvBuffer, cTelnetClient^ objTelnetClient)
{
    for(int nCount = 0; nCount < sRecvBuffer->Length; nCount++)
    {
        if(sRecvBuffer[nCount] == 8) // Client press backspace.
        {
            if(m_sRecvBuffer->Length == 0)
                return;
            
			array<System::Byte>^ sSendData = gcnew array<System::Byte> {32, 8};
			objTelnetClient->m_objSocket->Send(sSendData, 2, SocketFlags::None);

            m_sRecvBuffer = m_sRecvBuffer->Remove(m_sRecvBuffer->Length - 1, 1);
        }
        else
        {
             m_sRecvBuffer += sRecvBuffer[nCount];
        }
    }
}

String^ cTelnetRequest::FindRequest(cTelnetClient^ objTelnetClient)
{
    int nStart = m_sRecvBuffer->IndexOf("\r\n");

    if(nStart == -1) return "";

    String^ sCommand = m_sRecvBuffer->Substring(0, nStart);
    m_sRecvBuffer = m_sRecvBuffer->Remove(0, nStart + 2);

    if(sCommand->Length == 0)
        objTelnetClient->SendText("VaxTele:>");
    
    return sCommand;
}

bool cTelnetRequest::ParseRequest(String^ sRequest, String^% sCommand, ArrayList^% objParamList)
{
    int nEnd = sRequest->IndexOf(" ");

    if(nEnd == -1)
    {
        sCommand = sRequest;
        return true;
    }

    sCommand = sRequest->Substring(0, nEnd);
    sRequest = sRequest->Remove(0, nEnd + 1);

    while(true)
    {
        nEnd = sRequest->IndexOf(" ");

        if(nEnd == -1)
        {
            objParamList->Add(sRequest);
            break;
        }

        objParamList->Add(sRequest->Substring(0, nEnd));
        sRequest = sRequest->Remove(0, nEnd + 1);
    }

    return true;

}