// LineRegisterEvent.h: interface for the CLineRegisterEvent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LINEREGISTEREVENT_H__9EF2895C_44CC_44D6_82A7_DF9EF8164262__INCLUDED_)
#define AFX_LINEREGISTEREVENT_H__9EF2895C_44CC_44D6_82A7_DF9EF8164262__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CLineRegisterEvent  
{
public:
	CLineRegisterEvent();
	virtual ~CLineRegisterEvent();

public:

	void OnLineRegisterTrying(long lLineId);
	void OnLineRegisterFail(long lLineId, long lStatusCode, LPCTSTR sReasonPhrase);
	void OnLineRegisterSuccess(long lLineId);

	void OnLineUnRegisterTrying(long lLineId);
	void OnLineUnRegisterFail(long lLineId, long lStatusCode, LPCTSTR sReasonPhrase);
	void OnLineUnRegisterSuccess(long lLineId);

};

#endif // !defined(AFX_LINEREGISTEREVENT_H__9EF2895C_44CC_44D6_82A7_DF9EF8164262__INCLUDED_)
