#if !defined(AFX_TELNETSERVER_H__93974F2C_C5CA_4CA1_ACA9_FEE793F987FE__INCLUDED_)
#define AFX_TELNETSERVER_H__93974F2C_C5CA_4CA1_ACA9_FEE793F987FE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TelnetServer.h : header file
//

class CTelnetClient;

typedef CList<CTelnetClient*, CTelnetClient*> CTelnetClientList;

/////////////////////////////////////////////////////////////////////////////
// CTelnetServer command target

class CTelnetServer : public CAsyncSocket
{
// Attributes
public:

// Operations
public:
	
	CTelnetServer();
	virtual ~CTelnetServer();

private:

	CTelnetClientList* m_pClientList;
	CTelnetClientList* m_pDestroyList;
	
	CString m_sLoginTelnet;
	CString m_sPwdTelnet;

	void FreeMemory();
	
public:

	void SendCommandToAll(LPCTSTR sCommand, CStringList* pParamList);
	
	BOOL IsAuth(LPCTSTR sLogin, LPCTSTR sPassword);

	static CTelnetServer* m_pTelnetServer;

	void OnClientConnect(CTelnetClient* pTelnetClient);
	void OnClientDisconnect(CTelnetClient* pTelnetClient);

	BOOL StartServer();
	void StopServer();

	void CloseAllClient();

// Overrides
public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTelnetServer)
	public:
	virtual void OnAccept(int nErrorCode);
	//}}AFX_VIRTUAL

	// Generated message map functions
	//{{AFX_MSG(CTelnetServer)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

// Implementation
protected:
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TELNETSERVER_H__93974F2C_C5CA_4CA1_ACA9_FEE793F987FE__INCLUDED_)
