#include "StdAfx.h"
#include "ErrorLogForm.h"
#include "MainForm.h"

using namespace VaxTeleConfigSIP;

void ErrorLogForm::OnTelnetCommand(String^ sCommand, ArrayList^ objParamList)
{
	if(String::Compare(sCommand, "ErrorLog", true) == 0 && objParamList->Count == 1)
    {
		ListError->Items->Add(objParamList[0]);

		String^ sCaption = gcnew String("");
		
		sCaption = "Error log (" + Convert::ToString(ListError->Items->Count) + ")";
		MainForm::m_objMainForm->SetPageTitle(sCaption, 5);
	}
}

void ErrorLogForm::BtnClear_Click(System::Object^  sender, System::EventArgs^  e)
{
	ListError->Items->Clear();
	MainForm::m_objMainForm->SetPageTitle("Error log (0)", 5);
}