// ErrorLogDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleConfigSIP.h"
#include "ErrorLogDlg.h"
#include "MySheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CErrorLogDlg property page

IMPLEMENT_DYNCREATE(CErrorLogDlg, CPropertyPage)

CErrorLogDlg::CErrorLogDlg() : CPropertyPage(CErrorLogDlg::IDD)
{
	//{{AFX_DATA_INIT(CErrorLogDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_psp.dwFlags &= ~PSP_HASHELP;  // Lose the Help button
}

CErrorLogDlg::~CErrorLogDlg()
{
}

void CErrorLogDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CErrorLogDlg)
	DDX_Control(pDX, IDC_LIST_ERROR_LOG, m_ctrlErrorLogList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CErrorLogDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CErrorLogDlg)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CErrorLogDlg message handlers

void CErrorLogDlg::OnTelnetCommand(LPCTSTR sCommand, CStringList* pParamList)
{
	if(::lstrcmpi(sCommand, "ErrorLog") == 0 && pParamList->GetCount() == 1)
	{
		m_ctrlErrorLogList.AddString(pParamList->GetHead());

		CString sCaption;
		sCaption.Format("Error log (%d)", m_ctrlErrorLogList.GetCount());

		CMySheet* pMySheet = (CMySheet*) GetParent();
		pMySheet->SetPageTitle(sCaption, 5);
	}

}

void CErrorLogDlg::OnButtonClear() 
{
	m_ctrlErrorLogList.ResetContent();
	
	CMySheet* pMySheet = (CMySheet*) GetParent();
	pMySheet->SetPageTitle("Error log (0)", 5);	
}
